﻿using System;
using System.Threading;
using System.Threading.Tasks;

namespace ElementyProgramowaniaWspółbieżnego
{
    class Program
    {
        static private double obliczenia(double argument)
        {
            for(int i = 0; i< 100; i++)
            {
                argument = Math.Asin(Math.Sin(argument));
            }
            return argument;
        }

        static void Main(string[] args)
        {
            //przygotowanie
            int rozmiar = 10000;
            Random r = new Random();
            double[] tablica = new double[rozmiar];
            for (int i = 0; i < tablica.Length; ++i)
                tablica[i] = r.NextDouble();


            //obliczenia sekwencyjne
            int liczbaPowtórzeń = 100;
            double[] wyniki = new double[tablica.Length];
            int start = Environment.TickCount;
            for(int powtórzenia = 0; powtórzenia < liczbaPowtórzeń; powtórzenia++)
            {
                for (int i = 0; i < tablica.Length; ++i)
                    wyniki[i] = obliczenia(tablica[i]);
            }
            int stop = Environment.TickCount;
            int msSekwencyjne = stop - start;
            Console.WriteLine("Obliczenia sekwencyjne trwały " + msSekwencyjne.ToString() + " ms");

            //obliczenia równoległe            
            start = Environment.TickCount;
            for (int powtórzenia = 0; powtórzenia < liczbaPowtórzeń; powtórzenia++)
            {
                //for (int i = 0; i < tablica.Length; ++i) wyniki[i] = obliczenia(tablica[i]);
                Parallel.For(0, tablica.Length, (int i) => { wyniki[i] = obliczenia(tablica[i]); });
            }
            stop = Environment.TickCount;
            int msRównoległe = stop - start;
            Console.WriteLine("Obliczenia sekwencyjne trwały " + msRównoległe.ToString() + " ms");

            Console.WriteLine("Przyspieszenie: " + msSekwencyjne / (double)msRównoległe);


            //tworzenie zadania
            Console.WriteLine("1");
            Task t = Task.Run(() => 
            {
                Console.WriteLine("t1");
                Thread.Sleep(3000);
                Console.WriteLine("t2");
            });
            Console.WriteLine("2");
            t.Wait();
            Console.WriteLine("3");
        }
    }
}
